package gregapi.recipes.maps;

import static gregapi.data.CS.F;
import static gregapi.data.CS.GAPI_POST;
import static gregapi.data.CS.T;
import gregapi.data.OP;
import gregapi.oredict.OreDictItemData;
import gregapi.oredict.OreDictManager;
import gregapi.random.IHasWorldAndCoords;
import gregapi.recipes.Recipe;
import gregapi.recipes.Recipe.RecipeMap;
import gregapi.util.OM;
import gregapi.util.UT;

import java.util.Collection;
import java.util.List;

import net.minecraft.item.ItemStack;
import net.minecraftforge.fluids.FluidStack;

/**
 * @author Gregorius Techneticies
 */
public class RecipeMapChisel extends RecipeMap {
	public RecipeMapChisel(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aMinimalInputs, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed, boolean aNeedsOutputs) {
		super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aMinimalInputs, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed, aNeedsOutputs);
	}
	
	@Override
	public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
		Recipe rRecipe = super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
		if (aInputs == null || aInputs.length < 1 || aInputs[0] == null || GAPI_POST.mFinishedServerStarted <= 0) return rRecipe;
		if (rRecipe == null) {
			OreDictItemData tData = OM.anyassociation(aInputs[0]);
			if (tData != null && (tData.mPrefix == OP.blockDust || tData.mPrefix == OP.blockIngot || tData.mPrefix == OP.blockGem || tData.mPrefix == OP.blockPlate || tData.mPrefix == OP.blockPlateGem || tData.mPrefix == OP.blockSolid)) {
				List<ItemStack> tList = OreDictManager.getOres(tData.toString(), true);
				int tSize = tList.size();
				if (tSize > 0) {
					ItemStack tOutput = UT.Stacks.amount(1, tList.get(0));
					tSize--;
					for (int i = 0; i < tSize; i++) if (UT.Stacks.equal(aInputs[0], tList.get(i))) {tOutput = UT.Stacks.amount(1, tList.get(i+1)); break;}
					rRecipe = new Recipe(F, F, new ItemStack[] {UT.Stacks.amount(1, aInputs[0])}, new ItemStack[] {tOutput}, null, null, null, null, 96, 12, 0);
					rRecipe.mCanBeBuffered = T;
					return rRecipe;
				}
			}
		}
		return rRecipe;
	}
}